package binomialHeap

abstract class PriorityQueue{
  /** Insert x into the queue. */
  def insert(x: Int)

  /** Delete and return the minimum key. */
  def deleteMin : Option[Int]

  /** Return the minimum element of the queue. */
  def minimum : Option[Int]

  /** Perform a union, adding giver to this. */
  def union(giver: binomialHeap.concurrent.Union): Unit

  /** Shut down the queue, closing any log. */
  def shutdown : Unit
}
